VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form Form1 
   Caption         =   "PIC12F675 Oscilloscope - Wahoo-Wa.net"
   ClientHeight    =   7035
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   11760
   LinkTopic       =   "Form1"
   ScaleHeight     =   469
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   784
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkPauseRedraw 
      Caption         =   "Pause Redraw"
      Height          =   315
      Left            =   10260
      TabIndex        =   14
      Top             =   780
      Width           =   1395
   End
   Begin VB.TextBox txtArraySize 
      Height          =   315
      Left            =   7440
      TabIndex        =   12
      Text            =   "768"
      Top             =   720
      Width           =   675
   End
   Begin VB.Timer timerDraw 
      Interval        =   50
      Left            =   9480
      Top             =   300
   End
   Begin VB.HScrollBar scrollHLine1 
      Height          =   315
      LargeChange     =   10
      Left            =   3240
      Max             =   255
      TabIndex        =   9
      Top             =   360
      Width           =   2955
   End
   Begin VB.HScrollBar scrollHLine2 
      Height          =   315
      LargeChange     =   10
      Left            =   3240
      Max             =   255
      TabIndex        =   8
      Top             =   720
      Width           =   2955
   End
   Begin VB.TextBox txtTriggerHigh 
      Height          =   315
      Left            =   7680
      TabIndex        =   6
      Text            =   "100"
      Top             =   300
      Width           =   435
   End
   Begin VB.TextBox txtTriggerLow 
      Height          =   315
      Left            =   7080
      TabIndex        =   5
      Text            =   "20"
      Top             =   300
      Width           =   435
   End
   Begin VB.CheckBox chkLookForTrigger 
      Caption         =   "Use Trigger Values"
      Height          =   195
      Left            =   6300
      TabIndex        =   4
      Top             =   60
      Width           =   1815
   End
   Begin VB.HScrollBar scrollVLine2 
      Height          =   315
      LargeChange     =   10
      Left            =   120
      Max             =   500
      TabIndex        =   3
      Top             =   720
      Width           =   2955
   End
   Begin VB.HScrollBar scrollVLine1 
      Height          =   315
      LargeChange     =   10
      Left            =   120
      Max             =   500
      TabIndex        =   2
      Top             =   360
      Width           =   2955
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      Height          =   4695
      Left            =   60
      ScaleHeight     =   309
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   769
      TabIndex        =   1
      Top             =   1140
      Width           =   11595
   End
   Begin VB.TextBox txtInput 
      Height          =   1095
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   5880
      Width           =   11595
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   11220
      Top             =   3780
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      StopBits        =   2
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Sample Size:"
      Height          =   255
      Left            =   6300
      TabIndex        =   13
      Top             =   780
      Width           =   1095
   End
   Begin VB.Label lblDeltaH 
      Caption         =   "0"
      Height          =   255
      Left            =   3240
      TabIndex        =   11
      Top             =   60
      Width           =   2955
   End
   Begin VB.Label lblDeltaV 
      Caption         =   "0"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   60
      Width           =   2955
   End
   Begin VB.Label Label1 
      Caption         =   "-"
      Height          =   255
      Left            =   7560
      TabIndex        =   7
      Top             =   360
      Width           =   135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim dataArray As Variant
Private Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function SetPixelV Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal Color As Long) As Byte

Dim periodTimer As clsTimer

Dim theBigBuffer As String
Dim theXMult, theYMult As Double

Dim triggerSearch As Boolean
Dim lookForTrigger As Boolean
Dim msCalibrationConst As Double
Option Explicit

Private Sub chkLookForTrigger_Click()
    lookForTrigger = chkLookForTrigger.Value
End Sub

Private Sub Form_Load()
    ReDim dataArray(768) As Integer

    Set periodTimer = New clsTimer
    
    MSComm1.CommPort = 1
    MSComm1.Settings = "115200,N,8,2"
    MSComm1.InputLen = 0
    MSComm1.RThreshold = 1
    MSComm1.PortOpen = True
    scrollVLine1.Max = UBound(dataArray)
    scrollVLine2.Max = UBound(dataArray)
    
    triggerSearch = True
    lookForTrigger = False
    
    msCalibrationConst = 0.125
End Sub

Private Sub Form_Resize()
    Picture1.Height = Form1.ScaleHeight - (76 + Picture1.Top)
    Picture1.Width = Form1.ScaleWidth - 8
    txtInput.Top = Form1.ScaleHeight - (74)
    txtInput.Width = Form1.ScaleWidth - 8
    chkPauseRedraw.Left = Form1.ScaleWidth - 100
End Sub

Private Sub Form_Unload(Cancel As Integer)
    MSComm1.PortOpen = False
    Set periodTimer = Nothing
End Sub

Private Sub MSComm1_OnComm()
    Dim Buffer As String
    Dim theText As String
    Dim temp As Integer
    Dim i As Integer

    Select Case MSComm1.CommEvent
      Case comEvReceive   ' Received RThreshold # of chars.
                If chkPauseRedraw.Value = False Then
                    
                    If triggerSearch And lookForTrigger Then
                        theBigBuffer = MSComm1.Input
                        If Asc(theBigBuffer) >= Val(txtTriggerLow.Text) And Asc(theBigBuffer) <= Val(txtTriggerHigh.Text) Then
                            triggerSearch = False
                            theBigBuffer = ""
                            periodTimer.ResetTimer
                        End If
                    Else
                        theBigBuffer = theBigBuffer + MSComm1.Input
                    End If
                    
                    'Buffer = Mid(theBigBuffer, InStr(1, theBigBuffer, Chr(153)) + 1, UBound(dataArray))
                    Buffer = Mid(theBigBuffer, 1, UBound(dataArray))
                    
                    If Len(Buffer) = UBound(dataArray) Then
                        periodTimer.StopTimer
                        msCalibrationConst = (periodTimer.m_StopTime - periodTimer.m_StartTime) / periodTimer.m_curFrequency * 10000 * 1000
                        msCalibrationConst = Abs(msCalibrationConst) / UBound(dataArray)
                        'Buffer = Mid(Buffer, 1, Len(Buffer) - 1)
                        
                        Dim temp1, temp2 As String
                        For i = 0 To Len(Buffer) - 1
                            temp = Asc(Mid(Buffer, i + 1, 1))
                            dataArray(i) = temp
                        Next
                        
                        theText = "("
                        For i = 1 To UBound(dataArray)
                            theText = theText & Str(dataArray(i - 1)) & ","
                        Next
                        txtInput.Text = Mid(theText, 1, Len(theText) - 1) & ")"
                        
                        triggerSearch = True
                        theBigBuffer = ""
                        periodTimer.ResetTimer
                    End If
                    
                End If
   End Select
End Sub

Public Function drawArray()
    Dim theX, theY, oldX, oldY, i As Integer

    Picture1.Cls
    
    theXMult = Picture1.ScaleWidth / UBound(dataArray)
    theYMult = Picture1.ScaleHeight / 265
    
    Picture1.ForeColor = RGB(50, 50, 50)
    Picture1.Line (0, Picture1.ScaleHeight - theYMult * 51)-(Picture1.ScaleWidth, Picture1.ScaleHeight - theYMult * 51)
    Picture1.Line (0, Picture1.ScaleHeight - theYMult * 102)-(Picture1.ScaleWidth, Picture1.ScaleHeight - theYMult * 102)
    Picture1.Line (0, Picture1.ScaleHeight - theYMult * 154)-(Picture1.ScaleWidth, Picture1.ScaleHeight - theYMult * 154)
    Picture1.Line (0, Picture1.ScaleHeight - theYMult * 205)-(Picture1.ScaleWidth, Picture1.ScaleHeight - theYMult * 205)
    Picture1.Line (0, Picture1.ScaleHeight - theYMult * 255)-(Picture1.ScaleWidth, Picture1.ScaleHeight - theYMult * 255)
    Picture1.ForeColor = RGB(0, 255, 0)
    
    oldX = 0
    oldY = Picture1.ScaleHeight - theYMult * dataArray(0)

    For i = 0 To UBound(dataArray) - 1
        theX = theXMult * i
        theY = Picture1.ScaleHeight - theYMult * dataArray(i)
        Picture1.Line (oldX, oldY)-(theXMult * i, Picture1.ScaleHeight - theYMult * dataArray(i))
        oldX = theX
        oldY = theY
        'SetPixelV Picture1.hDC, theXMult * i, Picture1.ScaleHeight - theYMult * dataArray(i), RGB(0, 0, 0)
    Next
    lblDeltaV.Caption = Format(Abs(scrollVLine1.Value - scrollVLine2.Value) * msCalibrationConst, "###,###.000" & "ms")

    Picture1.ForeColor = RGB(100, 100, 255)
    Picture1.Line (theXMult * scrollVLine1.Value, 0)-(theXMult * scrollVLine1.Value, Picture1.ScaleHeight)
    Picture1.Line (theXMult * scrollVLine2.Value, 0)-(theXMult * scrollVLine2.Value, Picture1.ScaleHeight)
    
    Picture1.ForeColor = RGB(255, 100, 100)
    Picture1.Line (0, Picture1.ScaleHeight - theYMult * scrollHLine1.Value)-(Picture1.ScaleWidth, Picture1.ScaleHeight - theYMult * scrollHLine1.Value)
    Picture1.Line (0, Picture1.ScaleHeight - theYMult * scrollHLine2.Value)-(Picture1.ScaleWidth, Picture1.ScaleHeight - theYMult * scrollHLine2.Value)
    lblDeltaH.Caption = Format(Abs(scrollHLine1.Value - scrollHLine2.Value) * (5 / 255), "0.00" & "V")
End Function

Private Sub timerDraw_Timer()
    If UBound(dataArray) > 0 Then drawArray
End Sub

Private Sub txtArraySize_Change()
    If Val(txtArraySize.Text) > 0 Then
        ReDim Preserve dataArray(txtArraySize.Text) As Integer
        scrollVLine1.Max = UBound(dataArray)
        scrollVLine2.Max = UBound(dataArray)
    End If
End Sub
